Legrand / Raritan Xerus™ JSON-RPC API for Remote Access Devices like KX4-101, KX3G2

Loading...
Searching...
No Matches
Classes | Public Types | Public Member Functions | Public Attributes | List of all members
radm::PowerDevice Interface Reference
Inheritance diagram for radm::PowerDevice:

## Classes
struct | Settings
struct | SettingsChangedEvent
| Event: Device settings have changed. More...

## Public Types
enum | SnmpSecurityLevel { NO_AUTH_NO_PRIV , AUTH_NO_PRIV , AUTH_PRIV }
enum | SnmpAuthProtocol { MD5 , SHA1 , SHA224 , SHA256 , SHA384 , SHA512 }
enum | SnmpPrivProtocol { DES , AES128 , AES192 , AES256 , AES192_3DES , AES256_3DES }
enum | DeviceType { RARITAN , SERVER_TECHNOLOGY }
Public Types inherited from radm::Device
enum | State { UNKNOWN , INACTIVE , ACTIVE }

## Public Member Functions
Settings | getSettings ()
| Get device settings.
int | setSettings (in Settings settings)
| Set settings for this device.
int | resume ()
| Resume communication to this PDU.
vector< OutletPort > | getOutletPorts ()
| Get outlets belonging to this PDU.
Public Member Functions inherited from radm::Device
State | getState ()
| Get device state.
Metadata | getMetadata ()
| Get device meta data.
string | getName ()
| Get device name.
int | setName (in string name)
| Set device name.

## Public Attributes
constant int | ERR_READONLY_VALUE = 10
| A read-only value was changed.
constant int | ERR_SNMP_MIB_MISMATCH = 101
| The PDU's SNMP MIB is incompatible.
constant int | ERR_SNMP_TIMEOUT = 102
| SNMP response timeout.
constant int | ERR_SNMP_COMM_FAILURE = 103
| SNMP communication failed.
constant int | ERR_SNMP_NOACCESS = 104
| No access to SNMP resource.
constant int | ERR_SNMP_AUTHORIZATION = 105
| SNMP authorization error.
constant int | ERR_SNMP_INTERNAL_PROBLEM = 106
| An internal error was encountered during SNMP communication.
Public Attributes inherited from radm::Device
constant int | ERR_INVALID_ARGUMENT = 1
constant int | ERR_NOT_SUPPORTED = 2

## Detailed Description

Definition at line 8 of file PowerDevice.idl.

## Member Enumeration Documentation

## ◆ DeviceType

enum radm::PowerDevice::DeviceType

Definition at line 42 of file PowerDevice.idl.

## ◆ SnmpAuthProtocol

enum radm::PowerDevice::SnmpAuthProtocol

Enumerator
MD5 | MD5.
SHA1 | SHA-1.
SHA224 | SHA-224.
SHA256 | SHA-256.
SHA384 | SHA-384.
SHA512 | SHA-512.

Definition at line 24 of file PowerDevice.idl.

## ◆ SnmpPrivProtocol

enum radm::PowerDevice::SnmpPrivProtocol

Enumerator
DES | DES.
AES128 | AES-128.
AES192 | AES-192.
AES256 | AES-256.
AES192_3DES | AES-192 with key extension (3DES)
AES256_3DES | AES-256 with key extension (3DES)

Definition at line 33 of file PowerDevice.idl.

## ◆ SnmpSecurityLevel

enum radm::PowerDevice::SnmpSecurityLevel

Enumerator
NO_AUTH_NO_PRIV | no authentication, no privacy
AUTH_NO_PRIV | authentication, no privacy
AUTH_PRIV | authentication, privacy

Definition at line 18 of file PowerDevice.idl.

## Member Function Documentation

## ◆ getOutletPorts()

vector< OutletPort > radm::PowerDevice::getOutletPorts | ( |  | ) |

Get outlets belonging to this PDU.

Returns
  List of outlet ports

## ◆ getSettings()

Settings radm::PowerDevice::getSettings | ( |  | ) |

Get device settings.

Returns
  Device settings

## ◆ resume()

int radm::PowerDevice::resume | ( |  | ) |

Resume communication to this PDU.

Returns
  0 on success
  101 if the given host name was not found
  102 if the SNMP communication timed out
  103 if there was any other failure during SNMP communication
  104 if the PDU responded with 'no access'
  105 if the SNMP authorization failed
  106 if there was an internal problem during SNMP communication

## ◆ setSettings()

int radm::PowerDevice::setSettings | ( | in Settings | settings | ) |

Set settings for this device.

Parameters

  settings | New settings to set

Returns
  0 on success
  1 if any argument is invalid
  10 when changing any read-only value

## Member Data Documentation

## ◆ ERR_READONLY_VALUE

constant int radm::PowerDevice::ERR_READONLY_VALUE = 10

A read-only value was changed.

Definition at line 9 of file PowerDevice.idl.

## ◆ ERR_SNMP_AUTHORIZATION

constant int radm::PowerDevice::ERR_SNMP_AUTHORIZATION = 105

SNMP authorization error.

Definition at line 15 of file PowerDevice.idl.

## ◆ ERR_SNMP_COMM_FAILURE

constant int radm::PowerDevice::ERR_SNMP_COMM_FAILURE = 103

SNMP communication failed.

Definition at line 13 of file PowerDevice.idl.

## ◆ ERR_SNMP_INTERNAL_PROBLEM

constant int radm::PowerDevice::ERR_SNMP_INTERNAL_PROBLEM = 106

An internal error was encountered during SNMP communication.

Definition at line 16 of file PowerDevice.idl.

## ◆ ERR_SNMP_MIB_MISMATCH

constant int radm::PowerDevice::ERR_SNMP_MIB_MISMATCH = 101

The PDU's SNMP MIB is incompatible.

Definition at line 11 of file PowerDevice.idl.

## ◆ ERR_SNMP_NOACCESS

constant int radm::PowerDevice::ERR_SNMP_NOACCESS = 104

No access to SNMP resource.

Definition at line 14 of file PowerDevice.idl.

## ◆ ERR_SNMP_TIMEOUT

constant int radm::PowerDevice::ERR_SNMP_TIMEOUT = 102

SNMP response timeout.

Definition at line 12 of file PowerDevice.idl.

The documentation for this interface was generated from the following file:

- PowerDevice.idl